﻿/*
    MIT License

    Copyright (c) 2020 luca0N!

    Permission is hereby granted, free of charge, to any person obtaining a copy
    of this software and associated documentation files (the "Software"), to deal
    in the Software without restriction, including without limitation the rights
    to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    copies of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be included in all
    copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
    SOFTWARE.

    Contact me by e-mail via <mailto:luca0N@protonmail.com>.
*/
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace autenticador_do_luca0N
{
    public partial class Updater : Form
    {
        Main main;
        string version, url;
        public Updater(Main main, string version, string url)
        {
            InitializeComponent();
            this.version = version;
            this.url = url;
            this.main = main;
        }

        private void Updater_Load(object sender, EventArgs e)
        {
            ControlBox = false;
        }

        private void Updater_Shown(object sender, EventArgs e)
        {
            if (!Directory.Exists("./cache/"))
                Directory.CreateDirectory("./cache/");
            WebClient wc = new WebClient();
            wc.DownloadProgressChanged += (dlSender, dlE) => progressBar_dlProgress.Value = dlE.ProgressPercentage;
            wc.DownloadFileCompleted += (dlSender, dlE) => {
                main.RunUpdate(version);
                Close();
            };
            wc.DownloadFileAsync(new Uri(url), $"./cache/setup-{version}.exe");
            /*Task.Run(() =>
            {
            });*/
        }
    }
}
